package com.help;

package ..deTemp.1734944681566;

import com.google.common.collect.Maps;
import com.help.BiaoDanJianMoHelper;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Map;
import net.sf.json.JSONObject;
import okhttp3.MediaType;
import okhttp3.MultipartBody;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.RequestBody;
import okhttp3.Response;
import org.apache.commons.codec.digest.DigestUtils;
import weaver.conn.RecordSet;
import weaver.general.BaseBean;
import weaver.general.Util;
import weaver.interfaces.schedule.BaseCronJob;

public class VSPN_BankHelper extends BaseCronJob {
  public void execute(String requestid) throws Exception {
    RecordSet rs = new RecordSet();
    String tableName = "";
    rs.execute("select tablename from workflow_bill where id=(select formid from workflow_base  where id=(select workflowid from workflow_requestbase where requestid=" + requestid + "))");
    if (rs.next())
      tableName = rs.getString("tablename"); 
    String searchSql = "";
    searchSql = "select * from " + tableName + " where requestid='" + requestid + "'";
    rs.execute(searchSql);
    String fkptid = "";
    if (rs.next())
      fkptid = rs.getString("fkptid"); 
    String mchId = "";
    String merchantKey = "";
    searchSql = "select * from uf_tablefkptkey where id= '" + fkptid + "'";
    rs.execute(searchSql);
    if (rs.next()) {
      mchId = rs.getString("mchid");
      merchantKey = rs.getString("key1");
    } 
    if (tableName.equals("formtable_main_29")) {
      searchSql = "select * from formtable_main_29_dt2 where mainid=(select id from formtable_main_29 where requestid='" + requestid + "')";
      doMx(mchId, merchantKey, searchSql, requestid, "2");
    } else if (tableName.equals("formtable_main_33")) {
      searchSql = "select * from formtable_main_33_dt2 where mainid=(select id from formtable_main_33 where requestid='" + requestid + "')";
      doMx(mchId, merchantKey, searchSql, requestid, "2");
    } else if (tableName.equals("formtable_main_83")) {
      searchSql = "select * from formtable_main_83_dt2 where mainid=(select id from formtable_main_83 where requestid='" + requestid + "')";
      doMx(mchId, merchantKey, searchSql, requestid, "2");
    } else if (tableName.equals("formtable_main_66")) {
      searchSql = "select * from formtable_main_66_dt2 where mainid=(select id from formtable_main_66 where requestid='" + requestid + "')";
      doMx(mchId, merchantKey, searchSql, requestid, "2");
    } else if (tableName.equals("formtable_main_38")) {
      searchSql = "select * from formtable_main_38_dt1 where mainid=(select id from formtable_main_38 where requestid='" + requestid + "')";
      doMx(mchId, merchantKey, searchSql, requestid, "1");
      searchSql = "select * from formtable_main_38_dt2 where mainid=(select id from formtable_main_38 where requestid='" + requestid + "')";
      doMx(mchId, merchantKey, searchSql, requestid, "2");
      searchSql = "select * from formtable_main_38_dt3 where mainid=(select id from formtable_main_38 where requestid='" + requestid + "')";
      doMx(mchId, merchantKey, searchSql, requestid, "3");
      searchSql = "select * from formtable_main_38_dt4 where mainid=(select id from formtable_main_38 where requestid='" + requestid + "')";
      doMx(mchId, merchantKey, searchSql, requestid, "4");
    } else if (tableName.equals("formtable_main_37")) {
      searchSql = "select * from formtable_main_37 where requestid='" + requestid + "'";
      doMain(mchId, merchantKey, searchSql, requestid);
    } else if (tableName.equals("formtable_main_120")) {
      searchSql = "select * from formtable_main_120_dt1 where mainid=(select id from formtable_main_120 where requestid='" + requestid + "')";
      doMx(mchId, merchantKey, searchSql, requestid, "1");
    } else if (tableName.equals("formtable_main_279")) {
      searchSql = "select id,skf skr,sjh,yhzh,je skje,sfzh from formtable_main_279_dt4 where mainid=(select id from formtable_main_279 where requestid='" + requestid + "')";
      doMx(mchId, merchantKey, searchSql, requestid, "4");
    } 
  }
  
  public void doMain(String mchId, String merchantKey, String searchSql, String requestid) throws Exception {
    String transactionNo = "";
    String employeeName = "";
    String cellphone = "";
    String employeeAccount = "";
    String salary = "";
    String nationality = "中国";
    String certType = "0";
    String cardNo = "";
    String remark = "";
    RecordSet rs = new RecordSet();
    rs.execute(searchSql);
    while (rs.next()) {
      transactionNo = requestid + "_0_" + rs.getString("id");
      employeeName = rs.getString("xskr");
      cellphone = rs.getString("xsjh");
      employeeAccount = rs.getString("xyhzh");
      salary = rs.getString("fkje");
      cardNo = rs.getString("xsfzh");
      sendMsg(requestid, mchId, merchantKey, transactionNo, employeeName, cellphone, employeeAccount, salary, nationality, certType, cardNo, remark);
    } 
  }
  
  public void doMx(String mchId, String merchantKey, String searchSql, String requestid, String dt) throws Exception {
    String transactionNo = "";
    String employeeName = "";
    String cellphone = "";
    String employeeAccount = "";
    String salary = "";
    String nationality = "中国";
    String certType = "0";
    String cardNo = "";
    String remark = "";
    RecordSet rs = new RecordSet();
    rs.execute(searchSql);
    while (rs.next()) {
      transactionNo = requestid + "_" + dt + "_" + rs.getString("id");
      employeeName = rs.getString("skr");
      cellphone = rs.getString("sjh");
      employeeAccount = rs.getString("yhzh");
      salary = rs.getString("skje");
      cardNo = rs.getString("sfzh");
      sendMsg(requestid, mchId, merchantKey, transactionNo, employeeName, cellphone, employeeAccount, salary, nationality, certType, cardNo, remark);
    } 
  }
  
  public String sendMsg(String requestid, String mchId, String merchantKey, String transactionNo, String employeeName, String cellphone, String employeeAccount, String salary, String nationality, String certType, String cardNo, String remark) {
    BaseBean base = new BaseBean();
    String url = base.getPropValue("VSPN_BankHelper", "url");
    String signType = base.getPropValue("VSPN_BankHelper", "signType");
    String version = base.getPropValue("VSPN_BankHelper", "version");
    Map<String, String> postMap = Maps.newHashMap();
    postMap.put("mchId", mchId);
    postMap.put("signType", signType);
    postMap.put("version", version);
    String timestamp = String.valueOf(System.currentTimeMillis()).substring(0, 10);
    postMap.put("randStr", timestamp);
    JSONObject json = new JSONObject();
    json.put("transactionNo", transactionNo);
    json.put("employeeName", employeeName);
    json.put("cellphone", cellphone);
    json.put("employeeAccount", employeeAccount);
    json.put("salary", salary);
    json.put("nationality", nationality);
    json.put("certType", certType);
    json.put("cardNo", cardNo);
    json.put("remark", remark);
    postMap.put("data", json.toString());
    base.writeLog("VSPN_BankHelper-->sendMsg-->json-->" + json.toString());
    String ret = "";
    try {
      String requestSign = createLinkStringByGet(postMap);
      String hmac = SignByMD5(requestSign, merchantKey);
      postMap.put("sign", hmac);
      OkHttpClient client = (new OkHttpClient()).newBuilder().build();
      MediaType mediaType = MediaType.parse("text/plain");
      MultipartBody multipartBody = (new MultipartBody.Builder()).setType(MultipartBody.FORM).addFormDataPart("mchId", mchId).addFormDataPart("data", json.toString()).addFormDataPart("sign", hmac).addFormDataPart("signType", signType).addFormDataPart("version", version).addFormDataPart("randStr", timestamp).build();
      Request request = (new Request.Builder()).url(url).method("POST", (RequestBody)multipartBody).build();
      Response response = client.newCall(request).execute();
      String content = response.body().string();
      base.writeLog("VSPN_BankHelper-->sendMsg-->content-->" + content);
      JSONObject contentObj = JSONObject.fromObject(content);
      String status = Util.null2String(contentObj.get("code"));
      status = status.equals("200") ? "2" : "0";
      String errorMsg = "";
      if (contentObj.get("msg") != null && status.equals("0"))
        errorMsg = contentObj.getString("msg"); 
      RecordSet rs = new RecordSet();
      BiaoDanJianMoHelper help = new BiaoDanJianMoHelper();
      String modetablename = "uf_fkpt_fkqk";
      int modeid = Integer.parseInt(base.getPropValue("VSPN_BankHelper", "modeid"));
      int userid = 1;
      rs.execute("select creater from workflow_requestbase where requestid=" + requestid);
      if (rs.next())
        userid = rs.getInt("creater"); 
      String fkpt = "";
      rs.execute("select ptxz from uf_tablefkptkey where mchid='" + mchId + "'");
      if (rs.next())
        fkpt = rs.getString("ptxz"); 
      String updateSql = "update uf_fkpt_fkqk set fklsh='" + transactionNo + "',fkpt='" + fkpt + "',skr='" + employeeName + "',khyh='',yhzh='" + employeeAccount + "',sfzh='" + cardNo + "',sjh='" + cellphone + "',je='" + salary + "',fkzt='" + status + "',sbyy='" + errorMsg + "'";
      base.writeLog("VSPN_BankHelper-->日志-->updateSql-->" + updateSql);
      help.add(modetablename, modeid, userid, updateSql);
    } catch (Exception exception) {}
    return ret;
  }
  
  public String createLinkStringByGet(Map<String, String> params) {
    List<String> keys = new ArrayList<>(params.keySet());
    Collections.sort(keys);
    String str1 = "";
    for (int i = 0; i < keys.size(); i++) {
      String key = keys.get(i);
      Object value = params.get(key);
      if (value instanceof Integer)
        value = value; 
      if (i == keys.size() - 1) {
        str1 = str1 + value.toString();
      } else {
        str1 = str1 + value;
      } 
    } 
    return str1;
  }
  
  public String SignByMD5(String requestSign, String merchantKey) {
    String reqHmac = "";
    try {
      reqHmac = DigestUtils.md5Hex(requestSign + merchantKey).toUpperCase();
    } catch (Exception exception) {}
    return reqHmac;
  }
  
  public String nosign(String hp, String key) {
    JSONObject myJson = JSONObject.fromObject(hp);
    JSONObject jSONObject1 = myJson;
    String returnHmac = (String)jSONObject1.remove("sign");
    String Strmap = createLinkStringByGet((Map<String, String>)jSONObject1);
    String hmac1 = SignByMD5(Strmap, key);
    return hmac1;
  }
  
  public void execute() {
    BaseBean base = new BaseBean();
    base.writeLog("VSPN_BankHelper-->定时任务开始");
    String url = base.getPropValue("VSPN_BankHelper", "logurl");
    String signType = base.getPropValue("VSPN_BankHelper", "signType");
    String version = base.getPropValue("VSPN_BankHelper", "version");
    RecordSet rs = new RecordSet();
    RecordSet rs2 = new RecordSet();
    String fkptList = base.getPropValue("VSPN_BankHelper", "fkptList");
    rs.execute("SELECT * FROM uf_fkpt_fkqk WHERE fkzt!='0' AND modedatacreatedate >= NOW()-INTERVAL 3 DAY and fkpt in(" + fkptList + ")");
    while (rs.next()) {
      String transactionNo = rs.getString("fklsh");
      String fkpt = rs.getString("fkpt");
      rs2.execute("select mchid,key1 from uf_tablefkptkey where ptxz='" + fkpt + "'");
      if (rs2.next()) {
        String mchId = rs2.getString("mchid");
        String merchantKey = rs2.getString("key1");
        Map<String, String> postMap = Maps.newHashMap();
        postMap.put("mchId", mchId);
        postMap.put("signType", signType);
        postMap.put("version", version);
        String timestamp = String.valueOf(System.currentTimeMillis()).substring(0, 10);
        postMap.put("randStr", timestamp);
        JSONObject json = new JSONObject();
        json.put("transactionNo", transactionNo);
        postMap.put("data", json.toString());
        try {
          String requestSign = createLinkStringByGet(postMap);
          String hmac = SignByMD5(requestSign, merchantKey);
          postMap.put("sign", hmac);
          OkHttpClient client = (new OkHttpClient()).newBuilder().build();
          MediaType mediaType = MediaType.parse("text/plain");
          MultipartBody multipartBody = (new MultipartBody.Builder()).setType(MultipartBody.FORM).addFormDataPart("mchId", mchId).addFormDataPart("data", json.toString()).addFormDataPart("sign", hmac).addFormDataPart("signType", signType).addFormDataPart("version", version).addFormDataPart("randStr", timestamp).build();
          Request request = (new Request.Builder()).url(url).method("POST", (RequestBody)multipartBody).build();
          Response response = client.newCall(request).execute();
          String content = response.body().string();
          base.writeLog("VSPNN_BankHelper-->content-->" + content);
          JSONObject contentObj = JSONObject.fromObject(content);
          String status = Util.null2String(contentObj.get("code"));
          status = status.equals("200") ? "1" : "0";
          String errorMsg = Util.null2String(contentObj.get("msg"));
          if (status.equals("1")) {
            JSONObject dataObj = contentObj.getJSONObject("data");
            status = Util.null2String(dataObj.get("status"));
            if (!status.equals("1"))
              errorMsg = Util.null2String(dataObj.get("errorMsg")); 
          } 
          String updateSql = "update uf_fkpt_fkqk set fkzt='" + status + "',sbyy='" + errorMsg + "' where fklsh='" + transactionNo + "'";
          base.writeLog("VSPNN_BankHelper-->execute-->updateSql-->" + updateSql);
          rs2.execute(updateSql);
        } catch (Exception e) {
          base.writeLog("VSPNN_BankHelper-->execute-->e-->" + e.toString());
        } 
      } 
    } 
    base.writeLog("VSPN_BankHelper-->定时任务结束");
  }
  
  public void dolog(String transactionNo) {
    System.out.println("transactionNo:" + transactionNo);
    String url = "https://ally.bangdahr.com/zs/detail";
    String signType = "MD5";
    String version = "1.0";
    String mchId = "famuleimybd20211029160634687";
    String merchantKey = "9DubpSWf9z77UChWQidzatMdoLy7xagj";
    Map<String, String> postMap = Maps.newHashMap();
    postMap.put("mchId", mchId);
    postMap.put("signType", signType);
    postMap.put("version", version);
    String timestamp = String.valueOf(System.currentTimeMillis()).substring(0, 10);
    postMap.put("randStr", timestamp);
    JSONObject json = new JSONObject();
    json.put("transactionNo", transactionNo);
    postMap.put("data", json.toString());
    String ret = "";
    try {
      String requestSign = createLinkStringByGet(postMap);
      String hmac = SignByMD5(requestSign, merchantKey);
      postMap.put("sign", hmac);
      OkHttpClient client = (new OkHttpClient()).newBuilder().build();
      MediaType mediaType = MediaType.parse("text/plain");
      MultipartBody multipartBody = (new MultipartBody.Builder()).setType(MultipartBody.FORM).addFormDataPart("mchId", mchId).addFormDataPart("data", json.toString()).addFormDataPart("sign", hmac).addFormDataPart("signType", signType).addFormDataPart("version", version).addFormDataPart("randStr", timestamp).build();
      Request request = (new Request.Builder()).url(url).method("POST", (RequestBody)multipartBody).build();
      Response response = client.newCall(request).execute();
      String content = response.body().string();
      System.out.println("content:" + content);
    } catch (Exception exception) {}
  }
}
